/*
 * Copyright 2011, Maarten Baert <maarten-baert@hotmail.com>
 * 
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include "gm.h"
#include <cmath>
#include <cfloat>

class DisableFPExceptions {
	public:
	DisableFPExceptions() {
		_control87(_EM_INVALID|_EM_DENORMAL|_EM_ZERODIVIDE|_EM_OVERFLOW|_EM_UNDERFLOW|_EM_INEXACT, _MCW_EM);
	}
} disable_fp_exceptions;

gmexport double cmath_is_nan(double x) {
	return (__gnu_cxx::isnan(x))? 1 : 0;
}
gmexport double cmath_is_finite(double x) {
	return (__gnu_cxx::isfinite(x))? 1 : 0;
}
gmexport double cmath_is_infinite(double x) {
	return (__gnu_cxx::isinf(x))? 1 : 0;
}

gmexport double cmath_sin(double x) {
	return sin(x);
}
gmexport double cmath_cos(double x) {
	return cos(x);
}
gmexport double cmath_tan(double x) {
	return tan(x);
}
gmexport double cmath_asin(double x) {
	return asin(x);
}
gmexport double cmath_acos(double x) {
	return acos(x);
}
gmexport double cmath_atan(double x) {
	return atan(x);
}
gmexport double cmath_atan2(double y, double x) {
	return atan2(y, x);
}

gmexport double cmath_sinh(double x) {
	return sinh(x);
}
gmexport double cmath_cosh(double x) {
	return cosh(x);
}
gmexport double cmath_tanh(double x) {
	return tanh(x);
}

gmexport double cmath_exp(double x) {
	return exp(x);
}
gmexport double cmath_ln(double x) {
	return log(x);
}
gmexport double cmath_log2(double x) {
	return log(x)/M_LN2;
}
gmexport double cmath_log10(double x) {
	return log10(x);
}

gmexport double cmath_pow(double x, double n) {
	return pow(x, n);
}
gmexport double cmath_sqrt(double x) {
	return sqrt(x);
}

gmexport double cmath_floor(double x) {
	return floor(x);
}
gmexport double cmath_round(double x) {
	return floor(x+0.5);
}
gmexport double cmath_ceil(double x) {
	return ceil(x);
}
gmexport double cmath_abs(double x) {
	return fabs(x);
}

